clear all;
% Jawaban persamaan Laplace 2D

%%
%Parameter
nx=40;                           %Jumlah step x
ny=40;                           %Jumlah step y       
iter=100;                       %Jumlah iterasi 
hx=10/(nx-1);                    
hy=20/(ny-1);                     
x=0:hx:10;                        %Grid x
y=0:hy:20;                        %Grid y

%%
%Keadaan awal
p=zeros(nx,ny);          
pn=zeros(nx,ny);            

%%
%Syarat batas
p(:,1)=100;
p(:,nx)=0;
p(1,:)=0;                 
p(ny,:)=0;             

%%
%Iterasi
i=2:nx-1;
j=2:ny-1;
for it=1:iter
    pn=p;
    p(i,j)=1/(2*(hx^2+hy^2))*(hy^2*(pn(i+1,j)+pn(i-1,j))+hx^2*(pn(i,j+1)+pn(i,j-1)));
end
pp=transpose(p);
%%
%Plot Jawaban
mesh(x,y,pp,'EdgeColor','none');       
shading interp
title({'Persamaan Laplace 2D';['{Jumlah iterasi} = ',num2str(it)]})
xlabel('(x) \rightarrow')
ylabel('{\leftarrow} (y)')
zlabel('Distribusi suhu (T) \rightarrow')